import { Component } from '@angular/core';
import { IonicPage, NavController, NavParams } from 'ionic-angular';
import { Storage } from '@ionic/storage';
import {Myservice} from '../../providers/myservice';

/**
 * Generated class for the FixpricesPage page.
 *
 * See https://ionicframework.com/docs/components/#navigation for more info on
 * Ionic pages and navigation.
 */

@IonicPage()
@Component({
  selector: 'page-fixprices',
  templateUrl: 'fixprices.html',
})
export class FixpricesPage {
	
	services:any;
	garage_list:any;
	id:any
	constructor(public navCtrl: NavController, public navParams: NavParams,private myservice: Myservice,public storage:Storage) {
		this.storage.get('user_data').then((user_data) => {
			console.log(user_data);
			if(user_data){
				this.find_garage(user_data.id);
			}
	});
		this.services = this.navParams.get('service');
		
}

	ionViewDidLoad() {
		console.log('ionViewDidLoad FixpricesPage');
	}
	
	find_garage(user_id){
		this.myservice.show_loader();
		console.log('userid',this.id)
		this.myservice.load_get('find_garage/id/'+this.services.id+'/user_id/'+user_id).subscribe(data => {
			this.myservice.hide_loader();
			if(data.status == 'success'){
				this.garage_list = data.data;
				console.log(this.garage_list);
				// console.log(JSON.parse(this.garage_list[0].schedule))
			}
		});
	}
	
	shopdetail(id){
		this.navCtrl.push('ShopdetailPage',{'garage_id' : id,'page' : 'fixprice','services' :this.services});
	}
	back(){
		this.navCtrl.pop();
	}

}
